<template>
	<div class="sampling-form">
		<v-card-title class="px-0 d-flex align-start justify-space-between">
			<div>Sampling</div>
			<div class="text-body-2">
				<div v-if="location.properties.label">Location: {{ location.properties.label }}</div>
				<div v-if="location.properties.stratum">Stratum: {{ location.properties.stratum }}</div>
				<div v-if="location.properties.composite">Composite: {{ location.properties.composite }}</div>
				<div v-if="location.properties.bulkDensityRequired" class="text-body-2">Bulk Density Required</div>
			</div>
		</v-card-title>
		<v-text-field :value="timestamp" label="Timestamp" disabled />
		<div class="d-flex align-center">
			<v-text-field
				:value="`${sampling.geometry.coordinates.map((x) => x.toFixed(5)).join(', ')} (±${localizeDistance(
					sampling.properties.geoAccuracy
				).toFixed(0)} ${distanceUnit})`"
				label="Coordinates (lng, lat), accuracy"
				disabled
			/>
			<v-btn v-if="!submitted" icon @click="$emit('updateGeolocation')">
				<v-icon>mdi-crosshairs-gps</v-icon>
			</v-btn>
		</div>
		<depths-form
			:items="[sampling.soDepth]"
			:single="true"
			v-if="sampling.soDepth"
			@setDepths="onSetSamplingDepths"
			:disabled="submitted"
		/>
		<v-text-field
			:value="sampling.comment"
			@input="onCommentInput"
			label="Comment"
			placeholder=" "
			:disabled="submitted"
		/>
		<div class="text-caption">Samples</div>
		<div class="samples-wrapper py-2">
			<v-chip
				v-for="sample in samples"
				:key="sample.id"
				@click="() => onSampleSelect(sample)"
				class="pa-5 text-body-1"
				style="border-radius: 24px"
			>
				{{ `${sample.soDepth.minValue.value} - ${sample.soDepth.maxValue.value} cm` }}
				<v-icon class="ml-2" small>mdi-pencil</v-icon>
			</v-chip>
			<v-btn v-if="!submitted" @click="onSampleAddClick" small fab ourlined depressed color="primary">
				<v-icon>mdi-plus</v-icon>
			</v-btn>
		</div>
		<v-card-actions class="justify-end">
			<v-btn v-if="submitted" @click="onSamplingCancel" class="px-4" color="primary" outlined rounded>Close</v-btn>
			<v-btn v-if="!submitted" @click="onSamplingCancel" class="px-4" text rounded>Cancel</v-btn>
			<v-btn v-if="!submitted" @click="onSamplingSave" class="px-4 ml-2" color="primary" rounded> Save </v-btn>
		</v-card-actions>
		<v-dialog persistent v-model="dialogIsVisible" max-width="50em">
			<v-card>
				<v-card-text>
					<sample-form
						:sample="activeSample"
						:sampling="sampling"
						:samplingCollection="samplingCollection"
						:location="location"
						:submitted="submitted"
						@setSample="onSetSample"
						@cancelSample="dialogIsVisible = false"
						@deleteSample="onDeleteSample"
					/>
				</v-card-text>
			</v-card>
		</v-dialog>
	</div>
</template>

<script lang="ts">
import { computed, defineComponent, ref, watch } from '@vue/composition-api';
import DepthsForm from '@/components/forms/DepthsForm/DepthsForm.vue';
import SampleForm from '@/components/forms/SampleForm/SampleForm.vue';
import { SettingsService } from '@/services/storageService';
import { useEditSample } from '@/store/modules/samples';
import { Location, Sample, Sampling, SamplingCollection, SoDepth } from '@/store/types';
import { localizeDistance } from '@/views/sampling-collection/helpers';

export default defineComponent({
	props: {
		sampling: {
			type: Object as () => Sampling,
			required: true,
		},
		samplingCollection: {
			type: Object as () => SamplingCollection,
			required: true,
		},
		samples: {
			type: Array as () => Sample[],
		},
		location: {
			type: Object as () => Location,
		},
		submitted: {
			type: Boolean,
		},
	},
	components: {
		DepthsForm,
		SampleForm,
	},
	setup(props, { root, emit }) {
		const dialogIsVisible = ref<boolean>(false);
		const activeSample = ref<Sample>();
		const timestamp = computed<string>(() => new Date(props.sampling.resultTime).toLocaleString());
		const { clearError } = useEditSample(root.$store);
		const distanceUnit = SettingsService.getDistanceUnit();

		function onSetSamplingDepths(depths: SoDepth[]) {
			emit('setSamplingDepth', depths[0]);
		}

		function onCommentInput(value: string) {
			emit('setSamplingComment', value);
		}

		function onSampleAddClick() {
			// Set activeSample as undefined so that SampleForm will create new sample
			activeSample.value = undefined;
			dialogIsVisible.value = true;
		}

		function onSetSample(sample: Sample) {
			if (!props.submitted) {
				emit('setSamplingResult', sample);
			}
			dialogIsVisible.value = false;
		}

		function onSamplingCancel() {
			emit('samplingCancel');
		}

		function onSamplingSave() {
			emit('samplingSave', {
				sampling: props.sampling,
				samples: props.samples || [],
			});
		}

		function onSampleSelect(sample: Sample) {
			activeSample.value = sample;
			dialogIsVisible.value = true;
		}

		function onDeleteSample(id: string) {
			activeSample.value = undefined;
			emit('deleteSample', id);
			dialogIsVisible.value = false;
		}

		watch(
			() => dialogIsVisible.value,
			() => {
				clearError();
			}
		);

		return {
			onSetSamplingDepths,
			onCommentInput,
			onSampleAddClick,
			dialogIsVisible,
			onSetSample,
			onSamplingSave,
			onSamplingCancel,
			onSampleSelect,
			activeSample,
			onDeleteSample,
			timestamp,
			distanceUnit,
			localizeDistance,
		};
	},
});
</script>

<style scoped>
.sampling-form .samples-wrapper {
	display: flex;
	flex-wrap: wrap;
	gap: 8px;
}
</style>
